﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Script.Services;
using System.Web.Services;
using System.Web.UI.MobileControls;

[Serializable]
public class ProductDTO
{
    public int ProductID { get; set; }
    public string ProductNumber { get; set; }
    public string Name { get; set; }
    public string Color { get; set; }
    public decimal ListPrice { get; set; }
    public string FullSize { get; set; }
    public string Weight { get; set; }
    
    public ProductDTO(Product p)
    {
        ProductID = p.ProductID;
        ProductNumber = p.ProductNumber;
        Name = p.Name;
        Color = p.Color;
        ListPrice = p.ListPrice;
        FullSize = p.FullSize;
        Weight = p.Weight + p.WeightUnitMeasureCode;
    }

    public ProductDTO()
    {
        
    }
}

public class ResultStructure
{
    public object Result{get;set;}
    public int TotalCount { get; set; }
}

/// <summary>
/// Summary description for WebProductService
/// </summary>
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
//[GenerateScriptType(typeof(ProductDTO))]
//[GenerateScriptType(typeof(ResultStructure))]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
[System.Web.Script.Services.ScriptService]
public class WebProductService : System.Web.Services.WebService {

    public WebProductService () {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }

    [WebMethod]
    [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
    public ResultStructure GetProducts(string category, string subcategory, int skip)
    {
        DataClassesDataContext dcdc =
                new DataClassesDataContext(
                    "Data Source=localhost;Initial Catalog=AdventureWorks;Integrated Security=True");
        var query = from p in dcdc.Products select p;
        if (!string.IsNullOrEmpty(subcategory))
        {
            query = query.Where(p => p.ProductSubcategoryID == Convert.ToInt32(subcategory));
            
        }
        else
        {
            if (!string.IsNullOrEmpty(category))
            {
                query = query.Where(p => p.ProductSubcategory.ProductCategoryID == Convert.ToInt32(category));
            }
        }
        return new ResultStructure()
                   {
                       Result = query.Skip(skip).Take(10).Select(p => new ProductDTO(p)).ToList(),
                       TotalCount = query.Count()
                   };
    }
    
}

